;(getenv "ACAD")
(defun c:ATTI (/ $value att_list att_name dcl_id delta execute_it lst_att obj order slst ss star val)
  (defun dxf(id ent) (cdr (assoc id (entget ent))) )
  (vl-load-com)
  (if (and
	(setq obj (vlax-ename->vla-object (car (entsel "\nSelect Block attribute: "))))
	(setq lst_ATT (get_lst_ATT obj)) )
    (progn
      (setq dcl_id (load_dialog "ATTI.dcl"))
      (if (not (new_dialog "Atti" dcl_id))
	(alert "\nKhong tim duoc file ATTI.dcl !"))
      ;------- DCL Init  ------------
      (start_list "attdata" 3)
      (mapcar 'add_list lst_ATT)
      (end_list)
      (set_tile "attdata" "0")
      (setq att_list "0" order 1 star 1 delta 1);var init
      (action_tile "okay" "(done_dialog 1)")
      (action_tile "cancel" "(done_dialog)")
      (action_tile "attdata" "(setq att_list $value)")
      (action_tile "startstr"  "(setq star (atoi $value))")
      (action_tile "increment" "(setq delta (atoi $value))")
      (action_tile "order1" "(setq order 1)")
      (action_tile "order2" "(setq order 0)")
      (setq execute_it (start_dialog))
      (unload_dialog dcl_id)
      ;------- Main Program ------------
      (if (= execute_it 1)
	(progn
	  (setq att_name (nth (atoi att_list)lst_ATT))
	  (cond
	    ((= att_name "SO")
	     (princ "\nChon Block de cap nhat : ")
	     (setq ss (ssget (list (cons 0 "INSERT")(cons 2 (vla-get-Name obj)))) )
	     (setq sLst (mapcar 'vlax-ename->vla-object
				(vl-sort (vl-remove-if 'listp (mapcar 'cadr (ssnamex ss)))
					 '(lambda (x y)
					    (if (equal (car(setq x1 (trans (dxf 10 x) 0 1))) (car(setq y1 (trans (dxf 10 y) 0 1))))
					      (< (cadr x1) (cadr y1))
					      (< (car x1) (car y1))					      
					      )))) )
	     (if(= order 0) (setq sLst(reverse sLst)))
	     (setq val star)
	     (foreach e sLst
	       (Change_Attribute e att_name (itoa val))
	       (setq val (+ val delta))
	       )
	     )
	    (t (alert "   Opps !  Just Coding  ...  !   ") )
	    ) ; cond (setq att_lst '("SO" "COSBQ" "COSTK" "DTICH" "KLUONG"))
	  )
	)
       )
    (alert "Doi tuong da chon khong phai Block thuoc tinh !")
    )
  (princ))

(defun Change_Attribute (eobj tag newval / attlst enam eobj)
  (or (eq (type eobj) 'VLA-OBJECT)
    (setq eobj (vlax-ename->vla-object enam)))  
  (if (= (vla-get-HasAttributes eobj) :vlax-true)
   (progn
     (foreach att (vlax-invoke eobj 'GetAttributes)
       (if (= (strcase (vla-get-TagString att))(strcase tag))
	 (vl-catch-all-apply 'vla-put-textstring (list att newval)) )
     ) )
    nil
    )
  )

(defun get_lst_ATT (obj / lst)
  (setq lst (list))
  (if (and
	(= (vla-get-ObjectName obj)"AcDbBlockReference")
	(= (vla-get-HasAttributes obj) :vlax-true)
	(foreach att (vlax-invoke obj 'GetAttributes)
	  (setq lst (append lst (list(vla-get-TagString att)))) )
	)
    lst
    )
  )